#include "hyperbox.h"

//------------------------------------------------------------------------------------------
HyperBox::HyperBox():  Xin(), Xout(),Lchild(NB_CHILD_MAX)
{
    parent = NULL;  voisin = NULL;
}

//------------------------------------------------------------------------------------------
HyperBox::HyperBox(box &X): Xin(X), Xout(X),Lchild(NB_CHILD_MAX)
{
    parent = NULL;  voisin = NULL;
}

//------------------------------------------------------------------------------------------
HyperBox::HyperBox(HyperBox *P):  Xin(P->Xin.dim), Xout(P->Xin.dim),Lchild(NB_CHILD_MAX)
{
    parent = P;  voisin = NULL;
}

//------------------------------------------------------------------------------------------


bool HyperBox::IsEmpty()
{
    return (Xin & Xout).IsEmpty();
}

HyperBox::HyperBox(HyperBox &H)
{
}

HyperBox::~HyperBox ()
{
    while(!Lchild.empty()){
        HyperBox* H = Lchild.front(); Lchild.pop_front();
        delete H;
    }
}

void HyperBox::HyperBisect(HyperBox *H1, HyperBox *H2){
    box X = this->Xin & this->Xout;
    box X1, X2;
    Bisect(X,X1,X2);
    H1->Xin = X1; H1->Xout = X1;
    H2->Xin = X2; H2->Xout = X2;
    H1->setNeighbour(H2);
    H2->setNeighbour(H1);
    this->addChildren(H1,H2);
}

box HyperBox::X0()
{
    return Xin | Xout;
}


// -------------------------------------------------------------------------------
// -------------------------------------------------------------------------------
// ------------------------- GETTERS AND SETTER ----------------------------------
// -------------------------------------------------------------------------------
// -------------------------------------------------------------------------------

HyperBox *HyperBox::getParrent(){               return this->parent; }
// -------------------------------------------------------------------------------
void HyperBox::setParrent(HyperBox *parrent){   this->parent = parrent;  }
// -------------------------------------------------------------------------------
HyperBox *HyperBox::getChild(int num){
    if (Lchild.size() > num)
    {
        std::list<HyperBox*>::iterator it = Lchild.begin();
        std::advance(it, num);
        // 'it' points to the element at index 'N'
        return *it;
    }
    return NULL;
}
// -------------------------------------------------------------------------------
void HyperBox::setChild(HyperBox *H, int num){
    if (Lchild.size() > num)
    {
        std::list<HyperBox*>::iterator it = Lchild.begin();
        std::advance(it, num);
        // 'it' points to the element at index 'N'
        *it = H;
    }
}
// -------------------------------------------------------------------------------
HyperBox *HyperBox::getNeighbour(){                return voisin;}
// -------------------------------------------------------------------------------
void HyperBox::setNeighbour(HyperBox *H){          voisin = H;}
// -------------------------------------------------------------------------------
void HyperBox::addChildren(HyperBox* H1, HyperBox *H2){
    Lchild.push_back(H1);
    Lchild.push_back(H2);
}
// -------------------------------------------------------------------------------
void HyperBox::addChild(HyperBox* H1){ Lchild.push_back(H1);  }
// -------------------------------------------------------------------------------
void HyperBox::copyChildOf(HyperBox *H){
    for(uint i = 0; i < H->Lchild.size(); i++){
        Lchild.push_back(H->getChild(i));
    }
}
// -------------------------------------------------------------------------------
void HyperBox::clearChild() { Lchild.clear(); }
// -------------------------------------------------------------------------------
void HyperBox::removeChild(HyperBox *H) { Lchild.remove(H); }
// -------------------------------------------------------------------------------
void HyperBox::reduce(){
    for(uint i = 0; i < Lchild.size(); i++){
        HyperBox *H = getChild(i);
        if(H->IsEmpty()){
            HyperBox *V = H->voisin;
            clearChild();
            copyChildOf(V);
            V->clearChild();
            delete H; delete V;
        }
    }
}
// -------------------------------------------------------------------------------
