#ifndef HYPERBOX_H
#define HYPERBOX_H

#include "lib/box.h"
#include <QDebug>

#define NB_CHILD_MAX 0
class HyperBox
{
public:
    HyperBox();
    HyperBox(HyperBox &H);
    HyperBox(box &X0);
    HyperBox(HyperBox *P);
    ~HyperBox();

    box Xin;
    box Xout;

    HyperBox *parent;
    list<HyperBox*> Lchild;
    HyperBox* voisin;

    void HyperBisect(HyperBox *H1, HyperBox *H2);
    box X0();
    bool IsEmpty();
    void reduce();

    // ----------------------------------------------------------
    //          Getters and setters
    // ----------------------------------------------------------
    HyperBox * getParrent();
    void setParrent(HyperBox* parrent);
    HyperBox * getChild(int num);
    void setChild(HyperBox* H, int num);
    HyperBox * getNeighbour();
    void setNeighbour(HyperBox* H);

    // ----------------------------------------------------------
    // Deal with node children
    // ----------------------------------------------------------
    void addChildren(HyperBox *H1, HyperBox *H2);
    void removeChild(HyperBox* H);
    void addChild(HyperBox *H1);
    void copyChildOf(HyperBox *H);
    void clearChild();


private:


};

#endif // HYPERBOX_H
